Tool: update_model
Updates specific metadata fields (display_name, description, labels) of an existing Model or a specific version. Format: 'projects/{project_id}/locations/{region}/models/{model_id}'. CRITICAL: For {region}, use the region specified in the current context window. If no region is specified, prompt the user to provide one. Do not use 'global'. Use the updateMask parameter to specify fields (e.g., 'display_name', 'description'). Target a specific version using the '@' format in the model name.
The following sample demonstrate how to use curl to invoke the update_model MCP tool.
| Curl Request |
|---|
curl --location 'https://aiplatform.googleapis.com/mcp/generate' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "update_model", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' |
Input Schema
Request message for ModelService.UpdateModel.
UpdateModelRequest
| JSON representation |
|---|
{
"model": {
object ( |
| Fields | |
|---|---|
model |
Required. The Model which replaces the resource on the server. When Model Versioning is enabled, the model.name will be used to determine whether to update the model or model version. 1. model.name with the @ value, e.g. models/123@1, refers to a version specific update. 2. model.name without the @ value, e.g. models/123, refers to a model update. 3. model.name with @-, e.g. models/123@-, refers to a model update. 4. Supported model fields: display_name, description; supported version-specific fields: version_description. Labels are supported in both scenarios. Both the model labels and the version labels are merged when a model is returned. When updating labels, if the request is for model-specific update, model label gets updated. Otherwise, version labels get updated. 5. A model name or model version name fields update mismatch will cause a precondition error. 6. One request cannot update both the model and the version fields. You must update them separately. |
updateMask |
Required. The update mask applies to the resource. For the This is a comma-separated list of fully qualified names of fields. Example: |
Model
| JSON representation |
|---|
{ "name": string, "versionId": string, "versionAliases": [ string ], "versionCreateTime": string, "versionUpdateTime": string, "displayName": string, "description": string, "versionDescription": string, "defaultCheckpointId": string, "predictSchemata": { object ( |
| Fields | |
|---|---|
name |
Identifier. The resource name of the Model. |
versionId |
Output only. Immutable. The version ID of the model. A new version is committed when a new model version is uploaded or trained under an existing model id. It is an auto-incrementing decimal number in string representation. |
versionAliases[] |
User provided version aliases so that a model version can be referenced via alias (i.e. |
versionCreateTime |
Output only. Timestamp when this version was created. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
versionUpdateTime |
Output only. Timestamp when this version was most recently updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
displayName |
Required. The display name of the Model. The name can be up to 128 characters long and can consist of any UTF-8 characters. |
description |
The description of the Model. |
versionDescription |
The description of this version. |
defaultCheckpointId |
The default checkpoint id of a model version. |
predictSchemata |
The schemata that describe formats of the Model's predictions and explanations as given and returned via |
metadataSchemaUri |
Immutable. Points to a YAML file stored on Google Cloud Storage describing additional information about the Model, that is specific to it. Unset if the Model does not have any additional information. The schema is defined as an OpenAPI 3.0.2 Schema Object. AutoML Models always have this field populated by Vertex AI, if no additional metadata is needed, this field is set to an empty string. Note: The URI given on output will be immutable and probably different, including the URI scheme, than the one given on input. The output URI will point to a location where the user only has a read access. |
metadata |
Immutable. An additional information about the Model; the schema of the metadata can be found in |
supportedExportFormats[] |
Output only. The formats in which this Model may be exported. If empty, this Model is not available for export. |
trainingPipeline |
Output only. The resource name of the TrainingPipeline that uploaded this Model, if any. |
pipelineJob |
Optional. This field is populated if the model is produced by a pipeline job. |
containerSpec |
Input only. The specification of the container that is to be used when deploying this Model. The specification is ingested upon |
artifactUri |
Immutable. The path to the directory containing the Model artifact and any of its supporting files. Not required for AutoML Models. |
supportedDeploymentResourcesTypes[] |
Output only. When this Model is deployed, its prediction resources are described by the |
supportedInputStorageFormats[] |
Output only. The formats this Model supports in The possible formats are:
If this Model doesn't support any of these formats it means it cannot be used with a |
supportedOutputStorageFormats[] |
Output only. The formats this Model supports in The possible formats are:
If this Model doesn't support any of these formats it means it cannot be used with a |
createTime |
Output only. Timestamp when this Model was uploaded into Vertex AI. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
updateTime |
Output only. Timestamp when this Model was most recently updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
deployedModels[] |
Output only. The pointers to DeployedModels created from this Model. Note that Model could have been deployed to Endpoints in different Locations. |
explanationSpec |
The default explanation specification for this Model. The Model can be used for All fields of the explanation_spec can be overridden by If the default explanation specification is not set for this Model, this Model can still be used for |
etag |
Used to perform consistent read-modify-write updates. If not set, a blind "overwrite" update happens. |
labels |
The labels with user-defined metadata to organize your Models. Label keys and values can be no longer than 64 characters (Unicode codepoints), can only contain lowercase letters, numeric characters, underscores and dashes. International characters are allowed. See https://goo.gl/xmQnxf for more information and examples of labels. An object containing a list of |
dataStats |
Stats of data used for training or evaluating the Model. Only populated when the Model is trained by a TrainingPipeline with |
encryptionSpec |
Customer-managed encryption key spec for a Model. If set, this Model and all sub-resources of this Model will be secured by this key. |
modelSourceInfo |
Output only. Source of a model. It can either be automl training pipeline, custom training pipeline, BigQuery ML, or saved and tuned from Genie or Model Garden. |
originalModelInfo |
Output only. If this Model is a copy of another Model, this contains info about the original. |
metadataArtifact |
Output only. The resource name of the Artifact that was created in MetadataStore when creating the Model. The Artifact resource name pattern is |
baseModelSource |
Optional. User input field to specify the base model source. Currently it only supports specifing the Model Garden models and Genie models. |
satisfiesPzs |
Output only. Reserved for future use. |
satisfiesPzi |
Output only. Reserved for future use. |
checkpoints[] |
Optional. Output only. The checkpoints of the model. |
Timestamp
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z). |
nanos |
Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive. |
PredictSchemata
| JSON representation |
|---|
{ "instanceSchemaUri": string, "parametersSchemaUri": string, "predictionSchemaUri": string } |
| Fields | |
|---|---|
instanceSchemaUri |
Immutable. Points to a YAML file stored on Google Cloud Storage describing the format of a single instance, which are used in |
parametersSchemaUri |
Immutable. Points to a YAML file stored on Google Cloud Storage describing the parameters of prediction and explanation via |
predictionSchemaUri |
Immutable. Points to a YAML file stored on Google Cloud Storage describing the format of a single prediction produced by this Model, which are returned via |
Value
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field kind. The kind of value. kind can be only one of the following: |
|
nullValue |
Represents a JSON |
numberValue |
Represents a JSON number. Must not be |
stringValue |
Represents a JSON string. |
boolValue |
Represents a JSON boolean ( |
structValue |
Represents a JSON object. |
listValue |
Represents a JSON array. |
Struct
| JSON representation |
|---|
{ "fields": { string: value, ... } } |
| Fields | |
|---|---|
fields |
Unordered map of dynamically typed values. An object containing a list of |
FieldsEntry
| JSON representation |
|---|
{ "key": string, "value": value } |
| Fields | |
|---|---|
key |
|
value |
|
ListValue
| JSON representation |
|---|
{ "values": [ value ] } |
| Fields | |
|---|---|
values[] |
Repeated field of dynamically typed values. |
ExportFormat
| JSON representation |
|---|
{
"id": string,
"exportableContents": [
enum ( |
| Fields | |
|---|---|
id |
Output only. The ID of the export format. The possible format IDs are:
|
exportableContents[] |
Output only. The content of this Model that may be exported. |
ModelContainerSpec
| JSON representation |
|---|
{ "imageUri": string, "command": [ string ], "args": [ string ], "env": [ { object ( |
| Fields | |
|---|---|
imageUri |
Required. Immutable. URI of the Docker image to be used as the custom container for serving predictions. This URI must identify an image in Artifact Registry or Container Registry. Learn more about the container publishing requirements, including permissions requirements for the Vertex AI Service Agent. The container image is ingested upon To learn about the requirements for the Docker image itself, see Custom container requirements. You can use the URI to one of Vertex AI's pre-built container images for prediction in this field. |
command[] |
Immutable. Specifies the command that runs when the container starts. This overrides the container's ENTRYPOINT. Specify this field as an array of executable and arguments, similar to a Docker If you do not specify this field, then the container's If you specify this field, then you can also specify the In this field, you can reference environment variables set by Vertex AI and environment variables set in the
Note that this differs from Bash variable expansion, which does not use parentheses. If a variable cannot be resolved, the reference in the input string is used unchanged. To avoid variable expansion, you can escape this syntax with
This field corresponds to the |
args[] |
Immutable. Specifies arguments for the command that runs when the container starts. This overrides the container's If you don't specify this field but do specify the If you don't specify this field and don't specify the In this field, you can reference environment variables set by Vertex AI and environment variables set in the
Note that this differs from Bash variable expansion, which does not use parentheses. If a variable cannot be resolved, the reference in the input string is used unchanged. To avoid variable expansion, you can escape this syntax with
This field corresponds to the |
env[] |
Immutable. List of environment variables to set in the container. After the container starts running, code running in the container can read these environment variables. Additionally, the If you switch the order of the variables in the example, then the expansion does not occur. This field corresponds to the |
ports[] |
Immutable. List of ports to expose from the container. Vertex AI sends any prediction requests that it receives to the first port on this list. Vertex AI also sends liveness and health checks to this port. If you do not specify this field, it defaults to following value: Vertex AI does not use ports other than the first one listed. This field corresponds to the |
predictRoute |
Immutable. HTTP path on the container to send prediction requests to. Vertex AI forwards requests sent using For example, if you set this field to If you don't specify this field, it defaults to the following value when you
The placeholders in this value are replaced as follows:
|
healthRoute |
Immutable. HTTP path on the container to send health checks to. Vertex AI intermittently sends GET requests to this path on the container's IP address and port to check that the container is healthy. Read more about health checks. For example, if you set this field to If you don't specify this field, it defaults to the following value when you
The placeholders in this value are replaced as follows:
|
invokeRoutePrefix |
Immutable. Invoke route prefix for the custom container. "/*" is the only supported value right now. By setting this field, any non-root route on this model will be accessible with invoke http call eg: "/invoke/foo/bar", however the [PredictionService.Invoke] RPC is not supported yet. Only one of |
grpcPorts[] |
Immutable. List of ports to expose from the container. Vertex AI sends gRPC prediction requests that it receives to the first port on this list. Vertex AI also sends liveness and health checks to this port. If you do not specify this field, gRPC requests to the container will be disabled. Vertex AI does not use ports other than the first one listed. This field corresponds to the |
deploymentTimeout |
Immutable. Deployment timeout. Limit for deployment timeout is 2 hours. A duration in seconds with up to nine fractional digits, ending with ' |
sharedMemorySizeMb |
Immutable. The amount of the VM memory to reserve as the shared memory for the model in megabytes. |
startupProbe |
Immutable. Specification for Kubernetes startup probe. |
healthProbe |
Immutable. Specification for Kubernetes readiness probe. |
livenessProbe |
Immutable. Specification for Kubernetes liveness probe. |
EnvVar
| JSON representation |
|---|
{ "name": string, "value": string } |
| Fields | |
|---|---|
name |
Required. Name of the environment variable. Must be a valid C identifier. |
value |
Required. Variables that reference a $(VAR_NAME) are expanded using the previous defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. |
Port
| JSON representation |
|---|
{ "containerPort": integer } |
| Fields | |
|---|---|
containerPort |
The number of the port to expose on the pod's IP address. Must be a valid port number, between 1 and 65535 inclusive. |
Duration
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Signed seconds of the span of time. Must be from -315,576,000,000 to +315,576,000,000 inclusive. Note: these bounds are computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years |
nanos |
Signed fractions of a second at nanosecond resolution of the span of time. Durations less than one second are represented with a 0 |
Probe
| JSON representation |
|---|
{ "periodSeconds": integer, "timeoutSeconds": integer, "failureThreshold": integer, "successThreshold": integer, "initialDelaySeconds": integer, // Union field |
| Fields | |
|---|---|
periodSeconds |
How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1. Must be less than timeout_seconds. Maps to Kubernetes probe argument 'periodSeconds'. |
timeoutSeconds |
Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. Must be greater or equal to period_seconds. Maps to Kubernetes probe argument 'timeoutSeconds'. |
failureThreshold |
Number of consecutive failures before the probe is considered failed. Defaults to 3. Minimum value is 1. Maps to Kubernetes probe argument 'failureThreshold'. |
successThreshold |
Number of consecutive successes before the probe is considered successful. Defaults to 1. Minimum value is 1. Maps to Kubernetes probe argument 'successThreshold'. |
initialDelaySeconds |
Number of seconds to wait before starting the probe. Defaults to 0. Minimum value is 0. Maps to Kubernetes probe argument 'initialDelaySeconds'. |
Union field
|
|
exec |
ExecAction probes the health of a container by executing a command. |
httpGet |
HttpGetAction probes the health of a container by sending an HTTP GET request. |
grpc |
GrpcAction probes the health of a container by sending a gRPC request. |
tcpSocket |
TcpSocketAction probes the health of a container by opening a TCP socket connection. |
ExecAction
| JSON representation |
|---|
{ "command": [ string ] } |
| Fields | |
|---|---|
command[] |
Command is the command line to execute inside the container, the working directory for the command is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. |
HttpGetAction
| JSON representation |
|---|
{
"path": string,
"port": integer,
"host": string,
"scheme": string,
"httpHeaders": [
{
object ( |
| Fields | |
|---|---|
path |
Path to access on the HTTP server. |
port |
Number of the port to access on the container. Number must be in the range 1 to 65535. |
host |
Host name to connect to, defaults to the model serving container's IP. You probably want to set "Host" in httpHeaders instead. |
scheme |
Scheme to use for connecting to the host. Defaults to HTTP. Acceptable values are "HTTP" or "HTTPS". |
httpHeaders[] |
Custom headers to set in the request. HTTP allows repeated headers. |
HttpHeader
| JSON representation |
|---|
{ "name": string, "value": string } |
| Fields | |
|---|---|
name |
The header field name. This will be canonicalized upon output, so case-variant names will be understood as the same header. |
value |
The header field value |
GrpcAction
| JSON representation |
|---|
{ "port": integer, "service": string } |
| Fields | |
|---|---|
port |
Port number of the gRPC service. Number must be in the range 1 to 65535. |
service |
Service is the name of the service to place in the gRPC HealthCheckRequest. See https://github.com/grpc/grpc/blob/master/doc/health-checking.md. If this is not specified, the default behavior is defined by gRPC. |
TcpSocketAction
| JSON representation |
|---|
{ "port": integer, "host": string } |
| Fields | |
|---|---|
port |
Number of the port to access on the container. Number must be in the range 1 to 65535. |
host |
Optional: Host name to connect to, defaults to the model serving container's IP. |
DeployedModelRef
| JSON representation |
|---|
{ "endpoint": string, "deployedModelId": string, "checkpointId": string } |
| Fields | |
|---|---|
endpoint |
Immutable. A resource name of an Endpoint. |
deployedModelId |
Immutable. An ID of a DeployedModel in the above Endpoint. |
checkpointId |
Immutable. The ID of the Checkpoint deployed in the DeployedModel. |
ExplanationSpec
| JSON representation |
|---|
{ "parameters": { object ( |
| Fields | |
|---|---|
parameters |
Required. Parameters that configure explaining of the Model's predictions. |
metadata |
Optional. Metadata describing the Model's input and output for explanation. |
ExplanationParameters
| JSON representation |
|---|
{ "topK": integer, "outputIndices": array, // Union field |
| Fields | |
|---|---|
topK |
If populated, returns attributions for top K indices of outputs (defaults to 1). Only applies to Models that predicts more than one outputs (e,g, multi-class Models). When set to -1, returns explanations for all outputs. |
outputIndices |
If populated, only returns attributions that have If not populated, returns attributions for Only applicable to Models that predict multiple outputs (e,g, multi-class Models that predict multiple classes). |
Union field
|
|
sampledShapleyAttribution |
An attribution method that approximates Shapley values for features that contribute to the label being predicted. A sampling strategy is used to approximate the value rather than considering all subsets of features. Refer to this paper for model details: https://arxiv.org/abs/1306.4265. |
integratedGradientsAttribution |
An attribution method that computes Aumann-Shapley values taking advantage of the model's fully differentiable structure. Refer to this paper for more details: https://arxiv.org/abs/1703.01365 |
xraiAttribution |
An attribution method that redistributes Integrated Gradients attribution to segmented regions, taking advantage of the model's fully differentiable structure. Refer to this paper for more details: https://arxiv.org/abs/1906.02825 XRAI currently performs better on natural images, like a picture of a house or an animal. If the images are taken in artificial environments, like a lab or manufacturing line, or from diagnostic equipment, like x-rays or quality-control cameras, use Integrated Gradients instead. |
examples |
Example-based explanations that returns the nearest neighbors from the provided dataset. |
SampledShapleyAttribution
| JSON representation |
|---|
{ "pathCount": integer } |
| Fields | |
|---|---|
pathCount |
Required. The number of feature permutations to consider when approximating the Shapley values. Valid range of its value is [1, 50], inclusively. |
IntegratedGradientsAttribution
| JSON representation |
|---|
{ "stepCount": integer, "smoothGradConfig": { object ( |
| Fields | |
|---|---|
stepCount |
Required. The number of steps for approximating the path integral. A good value to start is 50 and gradually increase until the sum to diff property is within the desired error range. Valid range of its value is [1, 100], inclusively. |
smoothGradConfig |
Config for SmoothGrad approximation of gradients. When enabled, the gradients are approximated by averaging the gradients from noisy samples in the vicinity of the inputs. Adding noise can help improve the computed gradients. Refer to this paper for more details: https://arxiv.org/pdf/1706.03825.pdf |
blurBaselineConfig |
Config for IG with blur baseline. When enabled, a linear path from the maximally blurred image to the input image is created. Using a blurred baseline instead of zero (black image) is motivated by the BlurIG approach explained here: https://arxiv.org/abs/2004.03383 |
SmoothGradConfig
| JSON representation |
|---|
{ "noisySampleCount": integer, // Union field |
| Fields | |
|---|---|
noisySampleCount |
The number of gradient samples to use for approximation. The higher this number, the more accurate the gradient is, but the runtime complexity increases by this factor as well. Valid range of its value is [1, 50]. Defaults to 3. |
Union field GradientNoiseSigma. Represents the standard deviation of the gaussian kernel that will be used to add noise to the interpolated inputs prior to computing gradients. GradientNoiseSigma can be only one of the following: |
|
noiseSigma |
This is a single float value and will be used to add noise to all the features. Use this field when all features are normalized to have the same distribution: scale to range [0, 1], [-1, 1] or z-scoring, where features are normalized to have 0-mean and 1-variance. Learn more about normalization. For best results the recommended value is about 10% - 20% of the standard deviation of the input feature. Refer to section 3.2 of the SmoothGrad paper: https://arxiv.org/pdf/1706.03825.pdf. Defaults to 0.1. If the distribution is different per feature, set |
featureNoiseSigma |
This is similar to |
FeatureNoiseSigma
| JSON representation |
|---|
{
"noiseSigma": [
{
object ( |
| Fields | |
|---|---|
noiseSigma[] |
Noise sigma per feature. No noise is added to features that are not set. |
NoiseSigmaForFeature
| JSON representation |
|---|
{ "name": string, "sigma": number } |
| Fields | |
|---|---|
name |
The name of the input feature for which noise sigma is provided. The features are defined in |
sigma |
This represents the standard deviation of the Gaussian kernel that will be used to add noise to the feature prior to computing gradients. Similar to |
BlurBaselineConfig
| JSON representation |
|---|
{ "maxBlurSigma": number } |
| Fields | |
|---|---|
maxBlurSigma |
The standard deviation of the blur kernel for the blurred baseline. The same blurring parameter is used for both the height and the width dimension. If not set, the method defaults to the zero (i.e. black for images) baseline. |
XraiAttribution
| JSON representation |
|---|
{ "stepCount": integer, "smoothGradConfig": { object ( |
| Fields | |
|---|---|
stepCount |
Required. The number of steps for approximating the path integral. A good value to start is 50 and gradually increase until the sum to diff property is met within the desired error range. Valid range of its value is [1, 100], inclusively. |
smoothGradConfig |
Config for SmoothGrad approximation of gradients. When enabled, the gradients are approximated by averaging the gradients from noisy samples in the vicinity of the inputs. Adding noise can help improve the computed gradients. Refer to this paper for more details: https://arxiv.org/pdf/1706.03825.pdf |
blurBaselineConfig |
Config for XRAI with blur baseline. When enabled, a linear path from the maximally blurred image to the input image is created. Using a blurred baseline instead of zero (black image) is motivated by the BlurIG approach explained here: https://arxiv.org/abs/2004.03383 |
Examples
| JSON representation |
|---|
{ "neighborCount": integer, // Union field |
| Fields | |
|---|---|
neighborCount |
The number of neighbors to return when querying for examples. |
Union field
|
|
exampleGcsSource |
The Cloud Storage input instances. |
Union field
|
|
nearestNeighborSearchConfig |
The full configuration for the generated index, the semantics are the same as |
presets |
Simplified preset configuration, which automatically sets configuration values based on the desired query speed-precision trade-off and modality. |
ExampleGcsSource
| JSON representation |
|---|
{ "dataFormat": enum ( |
| Fields | |
|---|---|
dataFormat |
The format in which instances are given, if not specified, assume it's JSONL format. Currently only JSONL format is supported. |
gcsSource |
The Cloud Storage location for the input instances. |
GcsSource
| JSON representation |
|---|
{ "uris": [ string ] } |
| Fields | |
|---|---|
uris[] |
Required. Google Cloud Storage URI(-s) to the input file(s). May contain wildcards. For more information on wildcards, see https://cloud.google.com/storage/docs/wildcards. |
Presets
| JSON representation |
|---|
{ "modality": enum ( |
| Fields | |
|---|---|
modality |
The modality of the uploaded model, which automatically configures the distance measurement and feature normalization for the underlying example index and queries. If your model does not precisely fit one of these types, it is okay to choose the closest type. |
Union field
|
|
query |
Preset option controlling parameters for speed-precision trade-off when querying for examples. If omitted, defaults to |
ExplanationMetadata
| JSON representation |
|---|
{ "inputs": { string: { object ( |
| Fields | |
|---|---|
inputs |
Required. Map from feature names to feature input metadata. Keys are the name of the features. Values are the specification of the feature. An empty InputMetadata is valid. It describes a text feature which has the name specified as the key in For Vertex AI-provided Tensorflow images, the key can be any friendly name of the feature. Once specified, For custom images, the key must match with the key in An object containing a list of |
outputs |
Required. Map from output names to output metadata. For Vertex AI-provided Tensorflow images, keys can be any user defined string that consists of any UTF-8 characters. For custom images, keys are the name of the output field in the prediction to be explained. Currently only one key is allowed. An object containing a list of |
featureAttributionsSchemaUri |
Points to a YAML file stored on Google Cloud Storage describing the format of the |
latentSpaceSource |
Name of the source to generate embeddings for example based explanations. |
InputsEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
InputMetadata
| JSON representation |
|---|
{ "inputBaselines": [ value ], "inputTensorName": string, "encoding": enum ( |
| Fields | |
|---|---|
inputBaselines[] |
Baseline inputs for this feature. If no baseline is specified, Vertex AI chooses the baseline for this feature. If multiple baselines are specified, Vertex AI returns the average attributions across them in For Vertex AI-provided Tensorflow images (both 1.x and 2.x), the shape of each baseline must match the shape of the input tensor. If a scalar is provided, we broadcast to the same shape as the input tensor. For custom images, the element of the baselines must be in the same format as the feature's input in the |
inputTensorName |
Name of the input tensor for this feature. Required and is only applicable to Vertex AI-provided images for Tensorflow. |
encoding |
Defines how the feature is encoded into the input tensor. Defaults to IDENTITY. |
modality |
Modality of the feature. Valid values are: numeric, image. Defaults to numeric. |
featureValueDomain |
The domain details of the input feature value. Like min/max, original mean or standard deviation if normalized. |
indicesTensorName |
Specifies the index of the values of the input tensor. Required when the input tensor is a sparse representation. Refer to Tensorflow documentation for more details: https://www.tensorflow.org/api_docs/python/tf/sparse/SparseTensor. |
denseShapeTensorName |
Specifies the shape of the values of the input if the input is a sparse representation. Refer to Tensorflow documentation for more details: https://www.tensorflow.org/api_docs/python/tf/sparse/SparseTensor. |
indexFeatureMapping[] |
A list of feature names for each index in the input tensor. Required when the input |
encodedTensorName |
Encoded tensor is a transformation of the input tensor. Must be provided if choosing An encoded tensor is generated if the input tensor is encoded by a lookup table. |
encodedBaselines[] |
A list of baselines for the encoded tensor. The shape of each baseline should match the shape of the encoded tensor. If a scalar is provided, Vertex AI broadcasts to the same shape as the encoded tensor. |
visualization |
Visualization configurations for image explanation. |
groupName |
Name of the group that the input belongs to. Features with the same group name will be treated as one feature when computing attributions. Features grouped together can have different shapes in value. If provided, there will be one single attribution generated in |
FeatureValueDomain
| JSON representation |
|---|
{ "minValue": number, "maxValue": number, "originalMean": number, "originalStddev": number } |
| Fields | |
|---|---|
minValue |
The minimum permissible value for this feature. |
maxValue |
The maximum permissible value for this feature. |
originalMean |
If this input feature has been normalized to a mean value of 0, the original_mean specifies the mean value of the domain prior to normalization. |
originalStddev |
If this input feature has been normalized to a standard deviation of 1.0, the original_stddev specifies the standard deviation of the domain prior to normalization. |
Visualization
| JSON representation |
|---|
{ "type": enum ( |
| Fields | |
|---|---|
type |
Type of the image visualization. Only applicable to |
polarity |
Whether to only highlight pixels with positive contributions, negative or both. Defaults to POSITIVE. |
colorMap |
The color scheme used for the highlighted areas. Defaults to PINK_GREEN for Defaults to VIRIDIS for |
clipPercentUpperbound |
Excludes attributions above the specified percentile from the highlighted areas. Using the clip_percent_upperbound and clip_percent_lowerbound together can be useful for filtering out noise and making it easier to see areas of strong attribution. Defaults to 99.9. |
clipPercentLowerbound |
Excludes attributions below the specified percentile, from the highlighted areas. Defaults to 62. |
overlayType |
How the original image is displayed in the visualization. Adjusting the overlay can help increase visual clarity if the original image makes it difficult to view the visualization. Defaults to NONE. |
OutputsEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
OutputMetadata
| JSON representation |
|---|
{ "outputTensorName": string, // Union field |
| Fields | |
|---|---|
outputTensorName |
Name of the output tensor. Required and is only applicable to Vertex AI provided images for Tensorflow. |
Union field If neither of the fields are specified, |
|
indexDisplayNameMapping |
Static mapping between the index and display name. Use this if the outputs are a deterministic n-dimensional array, e.g. a list of scores of all the classes in a pre-defined order for a multi-classification Model. It's not feasible if the outputs are non-deterministic, e.g. the Model produces top-k classes or sort the outputs by their values. The shape of the value must be an n-dimensional array of strings. The number of dimensions must match that of the outputs to be explained. The |
displayNameMappingKey |
Specify a field name in the prediction to look for the display name. Use this if the prediction contains the display names for the outputs. The display names in the prediction must have the same shape of the outputs, so that it can be located by |
LabelsEntry
| JSON representation |
|---|
{ "key": string, "value": string } |
| Fields | |
|---|---|
key |
|
value |
|
DataStats
| JSON representation |
|---|
{ "trainingDataItemsCount": string, "validationDataItemsCount": string, "testDataItemsCount": string, "trainingAnnotationsCount": string, "validationAnnotationsCount": string, "testAnnotationsCount": string } |
| Fields | |
|---|---|
trainingDataItemsCount |
Number of DataItems that were used for training this Model. |
validationDataItemsCount |
Number of DataItems that were used for validating this Model during training. |
testDataItemsCount |
Number of DataItems that were used for evaluating this Model. If the Model is evaluated multiple times, this will be the number of test DataItems used by the first evaluation. If the Model is not evaluated, the number is 0. |
trainingAnnotationsCount |
Number of Annotations that are used for training this Model. |
validationAnnotationsCount |
Number of Annotations that are used for validating this Model during training. |
testAnnotationsCount |
Number of Annotations that are used for evaluating this Model. If the Model is evaluated multiple times, this will be the number of test Annotations used by the first evaluation. If the Model is not evaluated, the number is 0. |
EncryptionSpec
| JSON representation |
|---|
{ "kmsKeyName": string } |
| Fields | |
|---|---|
kmsKeyName |
Required. Resource name of the Cloud KMS key used to protect the resource. The Cloud KMS key must be in the same region as the resource. It must have the format |
ModelSourceInfo
| JSON representation |
|---|
{
"sourceType": enum ( |
| Fields | |
|---|---|
sourceType |
Type of the model source. |
copy |
If this Model is copy of another Model. If true then |
OriginalModelInfo
| JSON representation |
|---|
{ "model": string } |
| Fields | |
|---|---|
model |
Output only. The resource name of the Model this Model is a copy of, including the revision. Format: |
BaseModelSource
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
modelGardenSource |
Source information of Model Garden models. |
genieSource |
Information about the base model of Genie models. |
ModelGardenSource
| JSON representation |
|---|
{ "publicModelName": string, "versionId": string, "skipHfModelCache": boolean } |
| Fields | |
|---|---|
publicModelName |
Required. The model garden source model resource name. |
versionId |
Optional. The model garden source model version ID. |
skipHfModelCache |
Optional. Whether to avoid pulling the model from the HF cache. |
GenieSource
| JSON representation |
|---|
{ "baseModelUri": string } |
| Fields | |
|---|---|
baseModelUri |
Required. The public base model URI. |
Checkpoint
| JSON representation |
|---|
{ "checkpointId": string, "epoch": string, "step": string } |
| Fields | |
|---|---|
checkpointId |
The ID of the checkpoint. |
epoch |
The epoch of the checkpoint. |
step |
The step of the checkpoint. |
FieldMask
| JSON representation |
|---|
{ "paths": [ string ] } |
| Fields | |
|---|---|
paths[] |
The set of field mask paths. |
Output Schema
A trained machine learning Model.
Model
| JSON representation |
|---|
{ "name": string, "versionId": string, "versionAliases": [ string ], "versionCreateTime": string, "versionUpdateTime": string, "displayName": string, "description": string, "versionDescription": string, "defaultCheckpointId": string, "predictSchemata": { object ( |
| Fields | |
|---|---|
name |
Identifier. The resource name of the Model. |
versionId |
Output only. Immutable. The version ID of the model. A new version is committed when a new model version is uploaded or trained under an existing model id. It is an auto-incrementing decimal number in string representation. |
versionAliases[] |
User provided version aliases so that a model version can be referenced via alias (i.e. |
versionCreateTime |
Output only. Timestamp when this version was created. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
versionUpdateTime |
Output only. Timestamp when this version was most recently updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
displayName |
Required. The display name of the Model. The name can be up to 128 characters long and can consist of any UTF-8 characters. |
description |
The description of the Model. |
versionDescription |
The description of this version. |
defaultCheckpointId |
The default checkpoint id of a model version. |
predictSchemata |
The schemata that describe formats of the Model's predictions and explanations as given and returned via |
metadataSchemaUri |
Immutable. Points to a YAML file stored on Google Cloud Storage describing additional information about the Model, that is specific to it. Unset if the Model does not have any additional information. The schema is defined as an OpenAPI 3.0.2 Schema Object. AutoML Models always have this field populated by Vertex AI, if no additional metadata is needed, this field is set to an empty string. Note: The URI given on output will be immutable and probably different, including the URI scheme, than the one given on input. The output URI will point to a location where the user only has a read access. |
metadata |
Immutable. An additional information about the Model; the schema of the metadata can be found in |
supportedExportFormats[] |
Output only. The formats in which this Model may be exported. If empty, this Model is not available for export. |
trainingPipeline |
Output only. The resource name of the TrainingPipeline that uploaded this Model, if any. |
pipelineJob |
Optional. This field is populated if the model is produced by a pipeline job. |
containerSpec |
Input only. The specification of the container that is to be used when deploying this Model. The specification is ingested upon |
artifactUri |
Immutable. The path to the directory containing the Model artifact and any of its supporting files. Not required for AutoML Models. |
supportedDeploymentResourcesTypes[] |
Output only. When this Model is deployed, its prediction resources are described by the |
supportedInputStorageFormats[] |
Output only. The formats this Model supports in The possible formats are:
If this Model doesn't support any of these formats it means it cannot be used with a |
supportedOutputStorageFormats[] |
Output only. The formats this Model supports in The possible formats are:
If this Model doesn't support any of these formats it means it cannot be used with a |
createTime |
Output only. Timestamp when this Model was uploaded into Vertex AI. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
updateTime |
Output only. Timestamp when this Model was most recently updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
deployedModels[] |
Output only. The pointers to DeployedModels created from this Model. Note that Model could have been deployed to Endpoints in different Locations. |
explanationSpec |
The default explanation specification for this Model. The Model can be used for All fields of the explanation_spec can be overridden by If the default explanation specification is not set for this Model, this Model can still be used for |
etag |
Used to perform consistent read-modify-write updates. If not set, a blind "overwrite" update happens. |
labels |
The labels with user-defined metadata to organize your Models. Label keys and values can be no longer than 64 characters (Unicode codepoints), can only contain lowercase letters, numeric characters, underscores and dashes. International characters are allowed. See https://goo.gl/xmQnxf for more information and examples of labels. An object containing a list of |
dataStats |
Stats of data used for training or evaluating the Model. Only populated when the Model is trained by a TrainingPipeline with |
encryptionSpec |
Customer-managed encryption key spec for a Model. If set, this Model and all sub-resources of this Model will be secured by this key. |
modelSourceInfo |
Output only. Source of a model. It can either be automl training pipeline, custom training pipeline, BigQuery ML, or saved and tuned from Genie or Model Garden. |
originalModelInfo |
Output only. If this Model is a copy of another Model, this contains info about the original. |
metadataArtifact |
Output only. The resource name of the Artifact that was created in MetadataStore when creating the Model. The Artifact resource name pattern is |
baseModelSource |
Optional. User input field to specify the base model source. Currently it only supports specifing the Model Garden models and Genie models. |
satisfiesPzs |
Output only. Reserved for future use. |
satisfiesPzi |
Output only. Reserved for future use. |
checkpoints[] |
Optional. Output only. The checkpoints of the model. |
Timestamp
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z). |
nanos |
Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive. |
PredictSchemata
| JSON representation |
|---|
{ "instanceSchemaUri": string, "parametersSchemaUri": string, "predictionSchemaUri": string } |
| Fields | |
|---|---|
instanceSchemaUri |
Immutable. Points to a YAML file stored on Google Cloud Storage describing the format of a single instance, which are used in |
parametersSchemaUri |
Immutable. Points to a YAML file stored on Google Cloud Storage describing the parameters of prediction and explanation via |
predictionSchemaUri |
Immutable. Points to a YAML file stored on Google Cloud Storage describing the format of a single prediction produced by this Model, which are returned via |
Value
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field kind. The kind of value. kind can be only one of the following: |
|
nullValue |
Represents a JSON |
numberValue |
Represents a JSON number. Must not be |
stringValue |
Represents a JSON string. |
boolValue |
Represents a JSON boolean ( |
structValue |
Represents a JSON object. |
listValue |
Represents a JSON array. |
Struct
| JSON representation |
|---|
{ "fields": { string: value, ... } } |
| Fields | |
|---|---|
fields |
Unordered map of dynamically typed values. An object containing a list of |
FieldsEntry
| JSON representation |
|---|
{ "key": string, "value": value } |
| Fields | |
|---|---|
key |
|
value |
|
ListValue
| JSON representation |
|---|
{ "values": [ value ] } |
| Fields | |
|---|---|
values[] |
Repeated field of dynamically typed values. |
ExportFormat
| JSON representation |
|---|
{
"id": string,
"exportableContents": [
enum ( |
| Fields | |
|---|---|
id |
Output only. The ID of the export format. The possible format IDs are:
|
exportableContents[] |
Output only. The content of this Model that may be exported. |
ModelContainerSpec
| JSON representation |
|---|
{ "imageUri": string, "command": [ string ], "args": [ string ], "env": [ { object ( |
| Fields | |
|---|---|
imageUri |
Required. Immutable. URI of the Docker image to be used as the custom container for serving predictions. This URI must identify an image in Artifact Registry or Container Registry. Learn more about the container publishing requirements, including permissions requirements for the Vertex AI Service Agent. The container image is ingested upon To learn about the requirements for the Docker image itself, see Custom container requirements. You can use the URI to one of Vertex AI's pre-built container images for prediction in this field. |
command[] |
Immutable. Specifies the command that runs when the container starts. This overrides the container's ENTRYPOINT. Specify this field as an array of executable and arguments, similar to a Docker If you do not specify this field, then the container's If you specify this field, then you can also specify the In this field, you can reference environment variables set by Vertex AI and environment variables set in the
Note that this differs from Bash variable expansion, which does not use parentheses. If a variable cannot be resolved, the reference in the input string is used unchanged. To avoid variable expansion, you can escape this syntax with
This field corresponds to the |
args[] |
Immutable. Specifies arguments for the command that runs when the container starts. This overrides the container's If you don't specify this field but do specify the If you don't specify this field and don't specify the In this field, you can reference environment variables set by Vertex AI and environment variables set in the
Note that this differs from Bash variable expansion, which does not use parentheses. If a variable cannot be resolved, the reference in the input string is used unchanged. To avoid variable expansion, you can escape this syntax with
This field corresponds to the |
env[] |
Immutable. List of environment variables to set in the container. After the container starts running, code running in the container can read these environment variables. Additionally, the If you switch the order of the variables in the example, then the expansion does not occur. This field corresponds to the |
ports[] |
Immutable. List of ports to expose from the container. Vertex AI sends any prediction requests that it receives to the first port on this list. Vertex AI also sends liveness and health checks to this port. If you do not specify this field, it defaults to following value: Vertex AI does not use ports other than the first one listed. This field corresponds to the |
predictRoute |
Immutable. HTTP path on the container to send prediction requests to. Vertex AI forwards requests sent using For example, if you set this field to If you don't specify this field, it defaults to the following value when you
The placeholders in this value are replaced as follows:
|
healthRoute |
Immutable. HTTP path on the container to send health checks to. Vertex AI intermittently sends GET requests to this path on the container's IP address and port to check that the container is healthy. Read more about health checks. For example, if you set this field to If you don't specify this field, it defaults to the following value when you
The placeholders in this value are replaced as follows:
|
invokeRoutePrefix |
Immutable. Invoke route prefix for the custom container. "/*" is the only supported value right now. By setting this field, any non-root route on this model will be accessible with invoke http call eg: "/invoke/foo/bar", however the [PredictionService.Invoke] RPC is not supported yet. Only one of |
grpcPorts[] |
Immutable. List of ports to expose from the container. Vertex AI sends gRPC prediction requests that it receives to the first port on this list. Vertex AI also sends liveness and health checks to this port. If you do not specify this field, gRPC requests to the container will be disabled. Vertex AI does not use ports other than the first one listed. This field corresponds to the |
deploymentTimeout |
Immutable. Deployment timeout. Limit for deployment timeout is 2 hours. A duration in seconds with up to nine fractional digits, ending with ' |
sharedMemorySizeMb |
Immutable. The amount of the VM memory to reserve as the shared memory for the model in megabytes. |
startupProbe |
Immutable. Specification for Kubernetes startup probe. |
healthProbe |
Immutable. Specification for Kubernetes readiness probe. |
livenessProbe |
Immutable. Specification for Kubernetes liveness probe. |
EnvVar
| JSON representation |
|---|
{ "name": string, "value": string } |
| Fields | |
|---|---|
name |
Required. Name of the environment variable. Must be a valid C identifier. |
value |
Required. Variables that reference a $(VAR_NAME) are expanded using the previous defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. |
Port
| JSON representation |
|---|
{ "containerPort": integer } |
| Fields | |
|---|---|
containerPort |
The number of the port to expose on the pod's IP address. Must be a valid port number, between 1 and 65535 inclusive. |
Duration
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Signed seconds of the span of time. Must be from -315,576,000,000 to +315,576,000,000 inclusive. Note: these bounds are computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years |
nanos |
Signed fractions of a second at nanosecond resolution of the span of time. Durations less than one second are represented with a 0 |
Probe
| JSON representation |
|---|
{ "periodSeconds": integer, "timeoutSeconds": integer, "failureThreshold": integer, "successThreshold": integer, "initialDelaySeconds": integer, // Union field |
| Fields | |
|---|---|
periodSeconds |
How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1. Must be less than timeout_seconds. Maps to Kubernetes probe argument 'periodSeconds'. |
timeoutSeconds |
Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. Must be greater or equal to period_seconds. Maps to Kubernetes probe argument 'timeoutSeconds'. |
failureThreshold |
Number of consecutive failures before the probe is considered failed. Defaults to 3. Minimum value is 1. Maps to Kubernetes probe argument 'failureThreshold'. |
successThreshold |
Number of consecutive successes before the probe is considered successful. Defaults to 1. Minimum value is 1. Maps to Kubernetes probe argument 'successThreshold'. |
initialDelaySeconds |
Number of seconds to wait before starting the probe. Defaults to 0. Minimum value is 0. Maps to Kubernetes probe argument 'initialDelaySeconds'. |
Union field
|
|
exec |
ExecAction probes the health of a container by executing a command. |
httpGet |
HttpGetAction probes the health of a container by sending an HTTP GET request. |
grpc |
GrpcAction probes the health of a container by sending a gRPC request. |
tcpSocket |
TcpSocketAction probes the health of a container by opening a TCP socket connection. |
ExecAction
| JSON representation |
|---|
{ "command": [ string ] } |
| Fields | |
|---|---|
command[] |
Command is the command line to execute inside the container, the working directory for the command is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. |
HttpGetAction
| JSON representation |
|---|
{
"path": string,
"port": integer,
"host": string,
"scheme": string,
"httpHeaders": [
{
object ( |
| Fields | |
|---|---|
path |
Path to access on the HTTP server. |
port |
Number of the port to access on the container. Number must be in the range 1 to 65535. |
host |
Host name to connect to, defaults to the model serving container's IP. You probably want to set "Host" in httpHeaders instead. |
scheme |
Scheme to use for connecting to the host. Defaults to HTTP. Acceptable values are "HTTP" or "HTTPS". |
httpHeaders[] |
Custom headers to set in the request. HTTP allows repeated headers. |
HttpHeader
| JSON representation |
|---|
{ "name": string, "value": string } |
| Fields | |
|---|---|
name |
The header field name. This will be canonicalized upon output, so case-variant names will be understood as the same header. |
value |
The header field value |
GrpcAction
| JSON representation |
|---|
{ "port": integer, "service": string } |
| Fields | |
|---|---|
port |
Port number of the gRPC service. Number must be in the range 1 to 65535. |
service |
Service is the name of the service to place in the gRPC HealthCheckRequest. See https://github.com/grpc/grpc/blob/master/doc/health-checking.md. If this is not specified, the default behavior is defined by gRPC. |
TcpSocketAction
| JSON representation |
|---|
{ "port": integer, "host": string } |
| Fields | |
|---|---|
port |
Number of the port to access on the container. Number must be in the range 1 to 65535. |
host |
Optional: Host name to connect to, defaults to the model serving container's IP. |
DeployedModelRef
| JSON representation |
|---|
{ "endpoint": string, "deployedModelId": string, "checkpointId": string } |
| Fields | |
|---|---|
endpoint |
Immutable. A resource name of an Endpoint. |
deployedModelId |
Immutable. An ID of a DeployedModel in the above Endpoint. |
checkpointId |
Immutable. The ID of the Checkpoint deployed in the DeployedModel. |
ExplanationSpec
| JSON representation |
|---|
{ "parameters": { object ( |
| Fields | |
|---|---|
parameters |
Required. Parameters that configure explaining of the Model's predictions. |
metadata |
Optional. Metadata describing the Model's input and output for explanation. |
ExplanationParameters
| JSON representation |
|---|
{ "topK": integer, "outputIndices": array, // Union field |
| Fields | |
|---|---|
topK |
If populated, returns attributions for top K indices of outputs (defaults to 1). Only applies to Models that predicts more than one outputs (e,g, multi-class Models). When set to -1, returns explanations for all outputs. |
outputIndices |
If populated, only returns attributions that have If not populated, returns attributions for Only applicable to Models that predict multiple outputs (e,g, multi-class Models that predict multiple classes). |
Union field
|
|
sampledShapleyAttribution |
An attribution method that approximates Shapley values for features that contribute to the label being predicted. A sampling strategy is used to approximate the value rather than considering all subsets of features. Refer to this paper for model details: https://arxiv.org/abs/1306.4265. |
integratedGradientsAttribution |
An attribution method that computes Aumann-Shapley values taking advantage of the model's fully differentiable structure. Refer to this paper for more details: https://arxiv.org/abs/1703.01365 |
xraiAttribution |
An attribution method that redistributes Integrated Gradients attribution to segmented regions, taking advantage of the model's fully differentiable structure. Refer to this paper for more details: https://arxiv.org/abs/1906.02825 XRAI currently performs better on natural images, like a picture of a house or an animal. If the images are taken in artificial environments, like a lab or manufacturing line, or from diagnostic equipment, like x-rays or quality-control cameras, use Integrated Gradients instead. |
examples |
Example-based explanations that returns the nearest neighbors from the provided dataset. |
SampledShapleyAttribution
| JSON representation |
|---|
{ "pathCount": integer } |
| Fields | |
|---|---|
pathCount |
Required. The number of feature permutations to consider when approximating the Shapley values. Valid range of its value is [1, 50], inclusively. |
IntegratedGradientsAttribution
| JSON representation |
|---|
{ "stepCount": integer, "smoothGradConfig": { object ( |
| Fields | |
|---|---|
stepCount |
Required. The number of steps for approximating the path integral. A good value to start is 50 and gradually increase until the sum to diff property is within the desired error range. Valid range of its value is [1, 100], inclusively. |
smoothGradConfig |
Config for SmoothGrad approximation of gradients. When enabled, the gradients are approximated by averaging the gradients from noisy samples in the vicinity of the inputs. Adding noise can help improve the computed gradients. Refer to this paper for more details: https://arxiv.org/pdf/1706.03825.pdf |
blurBaselineConfig |
Config for IG with blur baseline. When enabled, a linear path from the maximally blurred image to the input image is created. Using a blurred baseline instead of zero (black image) is motivated by the BlurIG approach explained here: https://arxiv.org/abs/2004.03383 |
SmoothGradConfig
| JSON representation |
|---|
{ "noisySampleCount": integer, // Union field |
| Fields | |
|---|---|
noisySampleCount |
The number of gradient samples to use for approximation. The higher this number, the more accurate the gradient is, but the runtime complexity increases by this factor as well. Valid range of its value is [1, 50]. Defaults to 3. |
Union field GradientNoiseSigma. Represents the standard deviation of the gaussian kernel that will be used to add noise to the interpolated inputs prior to computing gradients. GradientNoiseSigma can be only one of the following: |
|
noiseSigma |
This is a single float value and will be used to add noise to all the features. Use this field when all features are normalized to have the same distribution: scale to range [0, 1], [-1, 1] or z-scoring, where features are normalized to have 0-mean and 1-variance. Learn more about normalization. For best results the recommended value is about 10% - 20% of the standard deviation of the input feature. Refer to section 3.2 of the SmoothGrad paper: https://arxiv.org/pdf/1706.03825.pdf. Defaults to 0.1. If the distribution is different per feature, set |
featureNoiseSigma |
This is similar to |
FeatureNoiseSigma
| JSON representation |
|---|
{
"noiseSigma": [
{
object ( |
| Fields | |
|---|---|
noiseSigma[] |
Noise sigma per feature. No noise is added to features that are not set. |
NoiseSigmaForFeature
| JSON representation |
|---|
{ "name": string, "sigma": number } |
| Fields | |
|---|---|
name |
The name of the input feature for which noise sigma is provided. The features are defined in |
sigma |
This represents the standard deviation of the Gaussian kernel that will be used to add noise to the feature prior to computing gradients. Similar to |
BlurBaselineConfig
| JSON representation |
|---|
{ "maxBlurSigma": number } |
| Fields | |
|---|---|
maxBlurSigma |
The standard deviation of the blur kernel for the blurred baseline. The same blurring parameter is used for both the height and the width dimension. If not set, the method defaults to the zero (i.e. black for images) baseline. |
XraiAttribution
| JSON representation |
|---|
{ "stepCount": integer, "smoothGradConfig": { object ( |
| Fields | |
|---|---|
stepCount |
Required. The number of steps for approximating the path integral. A good value to start is 50 and gradually increase until the sum to diff property is met within the desired error range. Valid range of its value is [1, 100], inclusively. |
smoothGradConfig |
Config for SmoothGrad approximation of gradients. When enabled, the gradients are approximated by averaging the gradients from noisy samples in the vicinity of the inputs. Adding noise can help improve the computed gradients. Refer to this paper for more details: https://arxiv.org/pdf/1706.03825.pdf |
blurBaselineConfig |
Config for XRAI with blur baseline. When enabled, a linear path from the maximally blurred image to the input image is created. Using a blurred baseline instead of zero (black image) is motivated by the BlurIG approach explained here: https://arxiv.org/abs/2004.03383 |
Examples
| JSON representation |
|---|
{ "neighborCount": integer, // Union field |
| Fields | |
|---|---|
neighborCount |
The number of neighbors to return when querying for examples. |
Union field
|
|
exampleGcsSource |
The Cloud Storage input instances. |
Union field
|
|
nearestNeighborSearchConfig |
The full configuration for the generated index, the semantics are the same as |
presets |
Simplified preset configuration, which automatically sets configuration values based on the desired query speed-precision trade-off and modality. |
ExampleGcsSource
| JSON representation |
|---|
{ "dataFormat": enum ( |
| Fields | |
|---|---|
dataFormat |
The format in which instances are given, if not specified, assume it's JSONL format. Currently only JSONL format is supported. |
gcsSource |
The Cloud Storage location for the input instances. |
GcsSource
| JSON representation |
|---|
{ "uris": [ string ] } |
| Fields | |
|---|---|
uris[] |
Required. Google Cloud Storage URI(-s) to the input file(s). May contain wildcards. For more information on wildcards, see https://cloud.google.com/storage/docs/wildcards. |
Presets
| JSON representation |
|---|
{ "modality": enum ( |
| Fields | |
|---|---|
modality |
The modality of the uploaded model, which automatically configures the distance measurement and feature normalization for the underlying example index and queries. If your model does not precisely fit one of these types, it is okay to choose the closest type. |
Union field
|
|
query |
Preset option controlling parameters for speed-precision trade-off when querying for examples. If omitted, defaults to |
ExplanationMetadata
| JSON representation |
|---|
{ "inputs": { string: { object ( |
| Fields | |
|---|---|
inputs |
Required. Map from feature names to feature input metadata. Keys are the name of the features. Values are the specification of the feature. An empty InputMetadata is valid. It describes a text feature which has the name specified as the key in For Vertex AI-provided Tensorflow images, the key can be any friendly name of the feature. Once specified, For custom images, the key must match with the key in An object containing a list of |
outputs |
Required. Map from output names to output metadata. For Vertex AI-provided Tensorflow images, keys can be any user defined string that consists of any UTF-8 characters. For custom images, keys are the name of the output field in the prediction to be explained. Currently only one key is allowed. An object containing a list of |
featureAttributionsSchemaUri |
Points to a YAML file stored on Google Cloud Storage describing the format of the |
latentSpaceSource |
Name of the source to generate embeddings for example based explanations. |
InputsEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
InputMetadata
| JSON representation |
|---|
{ "inputBaselines": [ value ], "inputTensorName": string, "encoding": enum ( |
| Fields | |
|---|---|
inputBaselines[] |
Baseline inputs for this feature. If no baseline is specified, Vertex AI chooses the baseline for this feature. If multiple baselines are specified, Vertex AI returns the average attributions across them in For Vertex AI-provided Tensorflow images (both 1.x and 2.x), the shape of each baseline must match the shape of the input tensor. If a scalar is provided, we broadcast to the same shape as the input tensor. For custom images, the element of the baselines must be in the same format as the feature's input in the |
inputTensorName |
Name of the input tensor for this feature. Required and is only applicable to Vertex AI-provided images for Tensorflow. |
encoding |
Defines how the feature is encoded into the input tensor. Defaults to IDENTITY. |
modality |
Modality of the feature. Valid values are: numeric, image. Defaults to numeric. |
featureValueDomain |
The domain details of the input feature value. Like min/max, original mean or standard deviation if normalized. |
indicesTensorName |
Specifies the index of the values of the input tensor. Required when the input tensor is a sparse representation. Refer to Tensorflow documentation for more details: https://www.tensorflow.org/api_docs/python/tf/sparse/SparseTensor. |
denseShapeTensorName |
Specifies the shape of the values of the input if the input is a sparse representation. Refer to Tensorflow documentation for more details: https://www.tensorflow.org/api_docs/python/tf/sparse/SparseTensor. |
indexFeatureMapping[] |
A list of feature names for each index in the input tensor. Required when the input |
encodedTensorName |
Encoded tensor is a transformation of the input tensor. Must be provided if choosing An encoded tensor is generated if the input tensor is encoded by a lookup table. |
encodedBaselines[] |
A list of baselines for the encoded tensor. The shape of each baseline should match the shape of the encoded tensor. If a scalar is provided, Vertex AI broadcasts to the same shape as the encoded tensor. |
visualization |
Visualization configurations for image explanation. |
groupName |
Name of the group that the input belongs to. Features with the same group name will be treated as one feature when computing attributions. Features grouped together can have different shapes in value. If provided, there will be one single attribution generated in |
FeatureValueDomain
| JSON representation |
|---|
{ "minValue": number, "maxValue": number, "originalMean": number, "originalStddev": number } |
| Fields | |
|---|---|
minValue |
The minimum permissible value for this feature. |
maxValue |
The maximum permissible value for this feature. |
originalMean |
If this input feature has been normalized to a mean value of 0, the original_mean specifies the mean value of the domain prior to normalization. |
originalStddev |
If this input feature has been normalized to a standard deviation of 1.0, the original_stddev specifies the standard deviation of the domain prior to normalization. |
Visualization
| JSON representation |
|---|
{ "type": enum ( |
| Fields | |
|---|---|
type |
Type of the image visualization. Only applicable to |
polarity |
Whether to only highlight pixels with positive contributions, negative or both. Defaults to POSITIVE. |
colorMap |
The color scheme used for the highlighted areas. Defaults to PINK_GREEN for Defaults to VIRIDIS for |
clipPercentUpperbound |
Excludes attributions above the specified percentile from the highlighted areas. Using the clip_percent_upperbound and clip_percent_lowerbound together can be useful for filtering out noise and making it easier to see areas of strong attribution. Defaults to 99.9. |
clipPercentLowerbound |
Excludes attributions below the specified percentile, from the highlighted areas. Defaults to 62. |
overlayType |
How the original image is displayed in the visualization. Adjusting the overlay can help increase visual clarity if the original image makes it difficult to view the visualization. Defaults to NONE. |
OutputsEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
OutputMetadata
| JSON representation |
|---|
{ "outputTensorName": string, // Union field |
| Fields | |
|---|---|
outputTensorName |
Name of the output tensor. Required and is only applicable to Vertex AI provided images for Tensorflow. |
Union field If neither of the fields are specified, |
|
indexDisplayNameMapping |
Static mapping between the index and display name. Use this if the outputs are a deterministic n-dimensional array, e.g. a list of scores of all the classes in a pre-defined order for a multi-classification Model. It's not feasible if the outputs are non-deterministic, e.g. the Model produces top-k classes or sort the outputs by their values. The shape of the value must be an n-dimensional array of strings. The number of dimensions must match that of the outputs to be explained. The |
displayNameMappingKey |
Specify a field name in the prediction to look for the display name. Use this if the prediction contains the display names for the outputs. The display names in the prediction must have the same shape of the outputs, so that it can be located by |
LabelsEntry
| JSON representation |
|---|
{ "key": string, "value": string } |
| Fields | |
|---|---|
key |
|
value |
|
DataStats
| JSON representation |
|---|
{ "trainingDataItemsCount": string, "validationDataItemsCount": string, "testDataItemsCount": string, "trainingAnnotationsCount": string, "validationAnnotationsCount": string, "testAnnotationsCount": string } |
| Fields | |
|---|---|
trainingDataItemsCount |
Number of DataItems that were used for training this Model. |
validationDataItemsCount |
Number of DataItems that were used for validating this Model during training. |
testDataItemsCount |
Number of DataItems that were used for evaluating this Model. If the Model is evaluated multiple times, this will be the number of test DataItems used by the first evaluation. If the Model is not evaluated, the number is 0. |
trainingAnnotationsCount |
Number of Annotations that are used for training this Model. |
validationAnnotationsCount |
Number of Annotations that are used for validating this Model during training. |
testAnnotationsCount |
Number of Annotations that are used for evaluating this Model. If the Model is evaluated multiple times, this will be the number of test Annotations used by the first evaluation. If the Model is not evaluated, the number is 0. |
EncryptionSpec
| JSON representation |
|---|
{ "kmsKeyName": string } |
| Fields | |
|---|---|
kmsKeyName |
Required. Resource name of the Cloud KMS key used to protect the resource. The Cloud KMS key must be in the same region as the resource. It must have the format |
ModelSourceInfo
| JSON representation |
|---|
{
"sourceType": enum ( |
| Fields | |
|---|---|
sourceType |
Type of the model source. |
copy |
If this Model is copy of another Model. If true then |
OriginalModelInfo
| JSON representation |
|---|
{ "model": string } |
| Fields | |
|---|---|
model |
Output only. The resource name of the Model this Model is a copy of, including the revision. Format: |
BaseModelSource
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
modelGardenSource |
Source information of Model Garden models. |
genieSource |
Information about the base model of Genie models. |
ModelGardenSource
| JSON representation |
|---|
{ "publicModelName": string, "versionId": string, "skipHfModelCache": boolean } |
| Fields | |
|---|---|
publicModelName |
Required. The model garden source model resource name. |
versionId |
Optional. The model garden source model version ID. |
skipHfModelCache |
Optional. Whether to avoid pulling the model from the HF cache. |
GenieSource
| JSON representation |
|---|
{ "baseModelUri": string } |
| Fields | |
|---|---|
baseModelUri |
Required. The public base model URI. |
Checkpoint
| JSON representation |
|---|
{ "checkpointId": string, "epoch": string, "step": string } |
| Fields | |
|---|---|
checkpointId |
The ID of the checkpoint. |
epoch |
The epoch of the checkpoint. |
step |
The step of the checkpoint. |
Tool Annotations
Destructive Hint: ✅ | Idempotent Hint: ✅ | Read Only Hint: ❌ | Open World Hint: ❌